-- ==============================================================
-- RTL generated by Vitis HLS - High-Level Synthesis from C, C++ and OpenCL v2022.1 (64-bit)
-- Version: 2022.1
-- Copyright (C) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity cache_module_cache_module_Pipeline_VITIS_LOOP_20_2 is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    ap_start : IN STD_LOGIC;
    ap_done : OUT STD_LOGIC;
    ap_idle : OUT STD_LOGIC;
    ap_ready : OUT STD_LOGIC;
    bf_lshr_cast : IN STD_LOGIC_VECTOR (0 downto 0);
    trunc_ln7 : IN STD_LOGIC_VECTOR (28 downto 0);
    cacheMemory_load_2_out : OUT STD_LOGIC_VECTOR (63 downto 0);
    cacheMemory_load_2_out_ap_vld : OUT STD_LOGIC;
    cacheMemory_address0 : OUT STD_LOGIC_VECTOR (2 downto 0);
    cacheMemory_ce0 : OUT STD_LOGIC;
    cacheMemory_q0 : IN STD_LOGIC_VECTOR (63 downto 0);
    ap_return : OUT STD_LOGIC_VECTOR (0 downto 0) );
end;


architecture behav of cache_module_cache_module_Pipeline_VITIS_LOOP_20_2 is 
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_logic_0 : STD_LOGIC := '0';
    constant ap_ST_fsm_state1 : STD_LOGIC_VECTOR (4 downto 0) := "00001";
    constant ap_ST_fsm_state2 : STD_LOGIC_VECTOR (4 downto 0) := "00010";
    constant ap_ST_fsm_state3 : STD_LOGIC_VECTOR (4 downto 0) := "00100";
    constant ap_ST_fsm_state4 : STD_LOGIC_VECTOR (4 downto 0) := "01000";
    constant ap_ST_fsm_state5 : STD_LOGIC_VECTOR (4 downto 0) := "10000";
    constant ap_const_boolean_1 : BOOLEAN := true;
    constant ap_const_lv32_0 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000000";
    constant ap_const_lv32_1 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000001";
    constant ap_const_lv1_0 : STD_LOGIC_VECTOR (0 downto 0) := "0";
    constant ap_const_lv32_2 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000010";
    constant ap_const_lv1_1 : STD_LOGIC_VECTOR (0 downto 0) := "1";
    constant ap_const_lv32_4 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000100";
    constant ap_const_lv32_3 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000000011";
    constant ap_const_lv3_0 : STD_LOGIC_VECTOR (2 downto 0) := "000";
    constant ap_const_lv3_4 : STD_LOGIC_VECTOR (2 downto 0) := "100";
    constant ap_const_lv3_1 : STD_LOGIC_VECTOR (2 downto 0) := "001";
    constant ap_const_lv32_1E : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011110";

attribute shreg_extract : string;
    signal ap_CS_fsm : STD_LOGIC_VECTOR (4 downto 0) := "00001";
    attribute fsm_encoding : string;
    attribute fsm_encoding of ap_CS_fsm : signal is "none";
    signal ap_CS_fsm_state1 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state1 : signal is "none";
    signal icmp_ln20_fu_114_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal icmp_ln20_reg_182 : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_CS_fsm_state2 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state2 : signal is "none";
    signal add_ln20_fu_120_p2 : STD_LOGIC_VECTOR (2 downto 0);
    signal add_ln20_reg_186 : STD_LOGIC_VECTOR (2 downto 0);
    signal cacheMemory_load_reg_196 : STD_LOGIC_VECTOR (63 downto 0);
    signal ap_CS_fsm_state3 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state3 : signal is "none";
    signal ap_phi_mux_UnifiedRetVal_phi_fu_98_p4 : STD_LOGIC_VECTOR (0 downto 0);
    signal UnifiedRetVal_reg_94 : STD_LOGIC_VECTOR (0 downto 0);
    signal ap_CS_fsm_state5 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state5 : signal is "none";
    signal ap_CS_fsm_state4 : STD_LOGIC;
    attribute fsm_encoding of ap_CS_fsm_state4 : signal is "none";
    signal zext_ln21_fu_137_p1 : STD_LOGIC_VECTOR (63 downto 0);
    signal i_fu_58 : STD_LOGIC_VECTOR (2 downto 0);
    signal icmp_ln21_fu_156_p2 : STD_LOGIC_VECTOR (0 downto 0);
    signal trunc_ln21_1_fu_142_p1 : STD_LOGIC_VECTOR (0 downto 0);
    signal trunc_ln21_fu_126_p1 : STD_LOGIC_VECTOR (1 downto 0);
    signal lshr_ln2_fu_130_p3 : STD_LOGIC_VECTOR (2 downto 0);
    signal trunc_ln21_3_fu_146_p4 : STD_LOGIC_VECTOR (28 downto 0);
    signal ap_return_preg : STD_LOGIC_VECTOR (0 downto 0) := "0";
    signal ap_NS_fsm : STD_LOGIC_VECTOR (4 downto 0);
    signal ap_ST_fsm_state1_blk : STD_LOGIC;
    signal ap_ST_fsm_state2_blk : STD_LOGIC;
    signal ap_ST_fsm_state3_blk : STD_LOGIC;
    signal ap_ST_fsm_state4_blk : STD_LOGIC;
    signal ap_ST_fsm_state5_blk : STD_LOGIC;
    signal ap_ce_reg : STD_LOGIC;


begin




    ap_CS_fsm_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_CS_fsm <= ap_ST_fsm_state1;
            else
                ap_CS_fsm <= ap_NS_fsm;
            end if;
        end if;
    end process;


    ap_return_preg_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_return_preg <= ap_const_lv1_0;
            else
                if ((ap_const_logic_1 = ap_CS_fsm_state4)) then 
                    ap_return_preg <= ap_phi_mux_UnifiedRetVal_phi_fu_98_p4;
                end if; 
            end if;
        end if;
    end process;


    UnifiedRetVal_reg_94_assign_proc : process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((icmp_ln20_reg_182 = ap_const_lv1_0) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
                UnifiedRetVal_reg_94 <= ap_const_lv1_0;
            elsif ((ap_const_logic_1 = ap_CS_fsm_state5)) then 
                UnifiedRetVal_reg_94 <= ap_const_lv1_1;
            end if; 
        end if;
    end process;

    i_fu_58_assign_proc : process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1))) then 
                i_fu_58 <= ap_const_lv3_0;
            elsif (((ap_const_logic_1 = ap_CS_fsm_state3) and (((trunc_ln21_1_fu_142_p1 = ap_const_lv1_0) and (icmp_ln20_reg_182 = ap_const_lv1_0)) or ((icmp_ln21_fu_156_p2 = ap_const_lv1_0) and (icmp_ln20_reg_182 = ap_const_lv1_0))))) then 
                i_fu_58 <= add_ln20_reg_186;
            end if; 
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if ((ap_const_logic_1 = ap_CS_fsm_state2)) then
                add_ln20_reg_186 <= add_ln20_fu_120_p2;
                icmp_ln20_reg_182 <= icmp_ln20_fu_114_p2;
            end if;
        end if;
    end process;
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((icmp_ln20_reg_182 = ap_const_lv1_0) and (ap_const_logic_1 = ap_CS_fsm_state3))) then
                cacheMemory_load_reg_196 <= cacheMemory_q0;
            end if;
        end if;
    end process;

    ap_NS_fsm_assign_proc : process (ap_start, ap_CS_fsm, ap_CS_fsm_state1, icmp_ln20_reg_182, ap_CS_fsm_state3, icmp_ln21_fu_156_p2, trunc_ln21_1_fu_142_p1)
    begin
        case ap_CS_fsm is
            when ap_ST_fsm_state1 => 
                if (((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_1))) then
                    ap_NS_fsm <= ap_ST_fsm_state2;
                else
                    ap_NS_fsm <= ap_ST_fsm_state1;
                end if;
            when ap_ST_fsm_state2 => 
                ap_NS_fsm <= ap_ST_fsm_state3;
            when ap_ST_fsm_state3 => 
                if (((ap_const_logic_1 = ap_CS_fsm_state3) and (((trunc_ln21_1_fu_142_p1 = ap_const_lv1_0) and (icmp_ln20_reg_182 = ap_const_lv1_0)) or ((icmp_ln21_fu_156_p2 = ap_const_lv1_0) and (icmp_ln20_reg_182 = ap_const_lv1_0))))) then
                    ap_NS_fsm <= ap_ST_fsm_state2;
                elsif (((icmp_ln20_reg_182 = ap_const_lv1_1) and (ap_const_logic_1 = ap_CS_fsm_state3))) then
                    ap_NS_fsm <= ap_ST_fsm_state5;
                else
                    ap_NS_fsm <= ap_ST_fsm_state4;
                end if;
            when ap_ST_fsm_state4 => 
                ap_NS_fsm <= ap_ST_fsm_state1;
            when ap_ST_fsm_state5 => 
                ap_NS_fsm <= ap_ST_fsm_state4;
            when others =>  
                ap_NS_fsm <= "XXXXX";
        end case;
    end process;
    add_ln20_fu_120_p2 <= std_logic_vector(unsigned(i_fu_58) + unsigned(ap_const_lv3_1));
    ap_CS_fsm_state1 <= ap_CS_fsm(0);
    ap_CS_fsm_state2 <= ap_CS_fsm(1);
    ap_CS_fsm_state3 <= ap_CS_fsm(2);
    ap_CS_fsm_state4 <= ap_CS_fsm(3);
    ap_CS_fsm_state5 <= ap_CS_fsm(4);

    ap_ST_fsm_state1_blk_assign_proc : process(ap_start)
    begin
        if ((ap_start = ap_const_logic_0)) then 
            ap_ST_fsm_state1_blk <= ap_const_logic_1;
        else 
            ap_ST_fsm_state1_blk <= ap_const_logic_0;
        end if; 
    end process;

    ap_ST_fsm_state2_blk <= ap_const_logic_0;
    ap_ST_fsm_state3_blk <= ap_const_logic_0;
    ap_ST_fsm_state4_blk <= ap_const_logic_0;
    ap_ST_fsm_state5_blk <= ap_const_logic_0;

    ap_done_assign_proc : process(ap_start, ap_CS_fsm_state1, ap_CS_fsm_state4)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state4) or ((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_0)))) then 
            ap_done <= ap_const_logic_1;
        else 
            ap_done <= ap_const_logic_0;
        end if; 
    end process;


    ap_idle_assign_proc : process(ap_start, ap_CS_fsm_state1)
    begin
        if (((ap_const_logic_1 = ap_CS_fsm_state1) and (ap_start = ap_const_logic_0))) then 
            ap_idle <= ap_const_logic_1;
        else 
            ap_idle <= ap_const_logic_0;
        end if; 
    end process;


    ap_phi_mux_UnifiedRetVal_phi_fu_98_p4_assign_proc : process(icmp_ln20_reg_182, UnifiedRetVal_reg_94, ap_CS_fsm_state4)
    begin
        if (((icmp_ln20_reg_182 = ap_const_lv1_0) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            ap_phi_mux_UnifiedRetVal_phi_fu_98_p4 <= ap_const_lv1_0;
        else 
            ap_phi_mux_UnifiedRetVal_phi_fu_98_p4 <= UnifiedRetVal_reg_94;
        end if; 
    end process;


    ap_ready_assign_proc : process(ap_CS_fsm_state4)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state4)) then 
            ap_ready <= ap_const_logic_1;
        else 
            ap_ready <= ap_const_logic_0;
        end if; 
    end process;


    ap_return_assign_proc : process(ap_phi_mux_UnifiedRetVal_phi_fu_98_p4, ap_CS_fsm_state4, ap_return_preg)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state4)) then 
            ap_return <= ap_phi_mux_UnifiedRetVal_phi_fu_98_p4;
        else 
            ap_return <= ap_return_preg;
        end if; 
    end process;

    cacheMemory_address0 <= zext_ln21_fu_137_p1(3 - 1 downto 0);

    cacheMemory_ce0_assign_proc : process(ap_CS_fsm_state2)
    begin
        if ((ap_const_logic_1 = ap_CS_fsm_state2)) then 
            cacheMemory_ce0 <= ap_const_logic_1;
        else 
            cacheMemory_ce0 <= ap_const_logic_0;
        end if; 
    end process;

    cacheMemory_load_2_out <= cacheMemory_load_reg_196;

    cacheMemory_load_2_out_ap_vld_assign_proc : process(icmp_ln20_reg_182, ap_CS_fsm_state4)
    begin
        if (((icmp_ln20_reg_182 = ap_const_lv1_0) and (ap_const_logic_1 = ap_CS_fsm_state4))) then 
            cacheMemory_load_2_out_ap_vld <= ap_const_logic_1;
        else 
            cacheMemory_load_2_out_ap_vld <= ap_const_logic_0;
        end if; 
    end process;

    icmp_ln20_fu_114_p2 <= "1" when (i_fu_58 = ap_const_lv3_4) else "0";
    icmp_ln21_fu_156_p2 <= "1" when (trunc_ln21_3_fu_146_p4 = trunc_ln7) else "0";
    lshr_ln2_fu_130_p3 <= (bf_lshr_cast & trunc_ln21_fu_126_p1);
    trunc_ln21_1_fu_142_p1 <= cacheMemory_q0(1 - 1 downto 0);
    trunc_ln21_3_fu_146_p4 <= cacheMemory_q0(30 downto 2);
    trunc_ln21_fu_126_p1 <= i_fu_58(2 - 1 downto 0);
    zext_ln21_fu_137_p1 <= std_logic_vector(IEEE.numeric_std.resize(unsigned(lshr_ln2_fu_130_p3),64));
end behav;
